package com.njzscloud.common.sn;

import com.njzscloud.common.core.utils.R;
import com.njzscloud.common.mp.support.PageParam;
import com.njzscloud.common.mp.support.PageResult;
import com.njzscloud.common.sn.support.SnUtil;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 编码配置表
 */
@Slf4j
@RestController
@RequestMapping("/sys_sn_config")
@RequiredArgsConstructor
public class SysSnConfigController {

    private final SysSnConfigService sysSnConfigService;

    /**
     * 新增
     *
     * @param addSnConfigParam 数据
     */
    @PostMapping("/add")
    public R<?> add(@Validated @RequestBody AddSnConfigParam addSnConfigParam) {
        sysSnConfigService.add(addSnConfigParam);
        return R.success();
    }

    @GetMapping("/next")
    public R<?> next(@RequestParam(required = false, defaultValue = "Default") String sncode) {
        return R.success(SnUtil.next(sncode));
    }

    /**
     * 修改
     *
     * @param sysSnConfigEntity 数据
     */
    @PostMapping("/modify")
    public R<?> modify(@RequestBody ModifySnConfigParam modifySnConfigParam) {
        sysSnConfigService.modify(modifySnConfigParam);
        return R.success();
    }

    /**
     * 删除
     *
     * @param ids Ids
     */
    @PostMapping("/del")
    public R<?> del(@RequestBody List<Long> ids) {
        sysSnConfigService.del(ids);
        return R.success();
    }

    /**
     * 详情
     *
     * @param id Id
     * @return SysSnConfigEntity 结果
     */
    @GetMapping("/detail")
    public R<SysSnConfigEntity> detail(@RequestParam Long id) {
        return R.success(sysSnConfigService.detail(id));
    }

    /**
     * 分页查询
     *
     * @param sysSnConfigEntity 筛选条件
     * @param pageParam         分页参数
     * @return PageResult&lt;SysSnConfigEntity&gt; 分页结果
     */
    @GetMapping("/paging")
    public R<PageResult<SysSnConfigEntity>> paging(PageParam pageParam, SysSnConfigEntity sysSnConfigEntity) {
        return R.success(sysSnConfigService.paging(pageParam, sysSnConfigEntity));
    }

}
